<!DOCTYPE html>
<html>
<head>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Course 365 - Learning with unlimited!</title>
  
  <!-- Nhúng các thư viện BS4 & jQuery, awesome font -->
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
  
  <!-- Các file css và js tự định nghĩa thêm -->
  <link rel="stylesheet" href="style.css">
  <script src="script.js"></script>
</head>
<body>
    <!-- 1. Header - Navbar menu -->
    <nav class="navbar navbar-expand-sm bg-light">
      <img src="images/Ionic_logo.png">
      <ul class="navbar-nav mr-auto">
        <li class="nav-item">
          <a class="nav-link" href="#">Home</a>
        </li>
        <li class="nav-item dropdown">
          <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
            Browse course
          </a>
          <div class="dropdown-menu" aria-labelledby="navbarDropdown">
            <a class="dropdown-item text-secondary" href="#">Web Development</a>
            <a class="dropdown-item text-secondary" href="#">Mobile App</a>
            <a class="dropdown-item text-secondary" href="#">Desktop App</a>
          </div>
        </li>
        <li class="nav-item dropdown">
          <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
            About us
          </a>
          <div class="dropdown-menu" aria-labelledby="navbarDropdown">
            <a class="dropdown-item text-secondary" href="#">Vision & Mission</a>
            <a class="dropdown-item text-secondary" href="#">Team</a>
            <a class="dropdown-item text-secondary" href="#">Contact Us</a>
          </div>
        </li>
      </ul>
      <form class="form-inline my-2 my-lg-0">
        <input class="form-control mr-sm-2" type="search" placeholder="Search Courses" aria-label="Search">
        <button class="btn btn-outline-primary my-2 my-sm-0" type="submit">Search</button>
      </form>
    </nav>
    <br>
    <!-- 2. Slide body -->
    <div id="slide-body" class = "bg-info">
      <div class = "row">
        <div class = "col-sm-7">
          <div id="slide-body-left" >
            <div class = "text-white">
              <h2>Welcome to Ionic Course365 Learning Center</h2>
            </div>
            <div class = "text-white">
              <p><small>Ionic Course365 is an online learning and teaching marketplace with over 5000 courses and 1 million students. Instructor and expertly crafted courses, designed for the modern students and entrepreneur.
              </small></p>
            </div>
            <div class = "row">
              <button class = "btn btn-warning m-1">Browse Course</button>
              <button class = "btn btn-light m-1">Become an Instructor</button>        
            </div>
          </div>
        </div>
        <div class = "col-sm-5 " id="slide-body-right">
          <img id="girl-img" src="images/ionic-207965.png">
        </div>
      </div>
    </div>
    <br>
    <!-- 3. Courses content -->
    <div id="course-content" class = "container">
      <h3>Recommended to you</h3>
      <div class = "row">
        <div class = "col-sm-3">
          <div class="card" style="width: 18rem;">
            <img class="card-img-top" src="images/courses/course-angular.jpg" alt="Card image cap">
            <div class="card-body">
              <p class="card-text text-primary font-weight-bold">How to easily create a website with Angular</p>
              <p class=" text-muted m-1"><i class = "far fa-clock"></i> 3h 56m Beginner</p>
              <p><span class="font-weight-bold m-1">$600</span><del class="text-muted m-1">$750</del></p>
            </div>
            <div class="card-footer">
              <div>
                <img class="img-teacher" src="images/teacher/morris_mccoy.jpg" alt="Avatar" style="width:30px">
                <small class="text-muted m-1">Morris Mccoy </small><i class="fa fa-bookmark float-right text-muted m-1"></i>
              </div>
            </div>
          </div>
        </div>
        <div class = "col-sm-3">
          <div class="card" style="width: 18rem;">
            <img class="card-img-top" src="images/courses/course-python.jpg" alt="Card image cap">
            <div class="card-body">
              <p class="card-text text-primary font-weight-bold">The Python Course: build web application</p>
              <p class=" text-muted m-1"><i class = "far fa-clock"></i> 4h 30m Advanced</p>
              <p><span class="font-weight-bold m-1">$900</span><del class="text-muted m-1">$1050</del></p>
            </div>
            <div class="card-footer">
              <div>
                <img class="img-teacher" src="images/teacher/claire_robertson.jpg" alt="Avatar" style="width:30px">
                <small class="text-muted m-1">Claire Robertson </small><i class="fa fa-bookmark float-right text-muted m-1"></i>
              </div>
            </div>
          </div>
        </div>
        <div class = "col-sm-3">
          <div class="card" style="width: 18rem;">
            <img class="card-img-top" src="images/courses/course-graphql.jpg" alt="Card image cap">
            <div class="card-body">
              <p class="card-text text-primary font-weight-bold">GraphQL: introduction to graphQL for beginners</p>
              <p class=" text-muted m-1"><i class = "far fa-clock"></i> 2h 15m Intermediate</p>
              <p><span class="font-weight-bold m-1">$650</span><del class="text-muted m-1">$850</del></p>
            </div>
            <div class="card-footer">
              <div>
                <img class="img-teacher" src="images/teacher/ted_hawkins.jpg" alt="Avatar" style="width:30px">
                <small class="text-muted m-1">Ted Hawkins </small><i class="fa fa-bookmark float-right text-muted m-1"></i>
              </div>
            </div>
          </div>
        </div>
        <div class = "col-sm-3">
          <div class="card" style="width: 18rem;">
            <img class="card-img-top" src="images/courses/course-javascript.jpg" alt="Card image cap">
            <div class="card-body">
              <p class="card-text text-primary font-weight-bold">Getting Started with <br>JavaScript</p>
              <p class=" text-muted m-1"><i class = "far fa-clock"></i> 3h34m Beginner</p>
              <p><span class="font-weight-bold m-1">$300</span><del class="text-muted m-1">$550</del></p>
            </div>
            <div class="card-footer">
              <div>
                <img class="img-teacher" src="images/teacher/ted_hawkins.jpg" alt="Avatar" style="width:30px">
                <small class="text-muted m-1">Ted Hawkins </small><i class="fa fa-bookmark float-right text-muted m-1"></i>
              </div>
            </div>
          </div>
        </div>
      </div>
      <br><br>
      <h3>Most Popular</h3>
      <div class = "row" id = "most-popular">
                
      </div>
      <br><br>
      <h3>Trending</h3>
      <div class = "row" id = "most-trending">
        
      </div>
    </div>
    <!-- 4. Footer -->
    <footer class = "container">
      <div class = "row m-4 small">
        <div class = "col-sm-8 text-muted">
          <p>© 2021 Ionic Course365. All Rights Reserved.</p>
        </div>
        <div class = "col-sm-4">
          <div class = "row float-right">
            <a class="nav-link" href="#">Privacy</a>
            <a class="nav-link" href="#">Terms</a>
            <a class="nav-link" href="#">Feedback</a>
            <a class="nav-link" href="#">Support</a>
          </div>
        </div>
      </div>
      
    </footer>
</body>
<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gBASE_URL = "https://630890e4722029d9ddd245bc.mockapi.io/api/v1";
    const gCONTENT_TYPE = "application/json";

    // Biến toàn cục để lưu trữ thông tin các khóa học. Mặc định = rỗng;
    var gCourseArr = [];
    
    var gCourseTrendingArr = [];
  
  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  $(document).ready(function(){
    onPageLoading();
  });
  
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */  
  //hàm xử lý sự kiện tải trang
  function onPageLoading(){
      //1-R: Read 
      getAllCourses();
    }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //hàm load toàn bộ dữ liệu khóa học
    function getAllCourses(){
      $.ajax({
            url: gBASE_URL + "/courses",
            type: "GET",
            success: function(paramCourses){
                console.log(paramCourses);
                //gán vào biến toàn cục
                gCourseArr = paramCourses;
                //b4: Xử lý hiển thị
                displayPopularCourses(gCourseArr);
                displayTrendingCourses(gCourseArr);
                
            },
            error: function(paramErr){
                console.log(paramErr.status);
            }
        });
    }
    //hàm lọc danh sách các khóa học popular
    function getPopularCourses(paramCourseArr){
      var vCoursePopularArr = [];
      vCoursePopularArr = paramCourseArr.filter(function(paramCourse){
        return (paramCourse.isPopular == true);
      })
      return vCoursePopularArr;
    }
    //hàm lọc danh sách các khóa học trending
    function getTrendingCourses(paramCourseArr){
      var vCourseTrendingArr = [];
      vCourseTrendingArr = paramCourseArr.filter(function(paramCourse){
        return (paramCourse.isTrending == true);
      })
      return vCourseTrendingArr;
    }
    //hàm hiển thị các khóa học popular
    function displayPopularCourses(paramCourseArr){
      console.log("Các khóa học popular: ");
      console.log(getPopularCourses(paramCourseArr));
      var vCoursePopularArr = getPopularCourses(paramCourseArr);
      var i=0;
      while (i< 4 && i<= vCoursePopularArr.length){
        displayCardPopular(vCoursePopularArr[i]);
        i++;
      }
    };
    //hàm hiển thị các khóa học trending
    function displayTrendingCourses(paramCourseArr){
      console.log("Các khóa học trending: ");
      console.log(getTrendingCourses(paramCourseArr));
      var vCourseTrendingArr = getTrendingCourses(paramCourseArr);
      var i=0;
      while (i< 4 && i<= vCourseTrendingArr.length){
        displayCardTrending(vCourseTrendingArr[i]);
        i++;
      }
    };
    //hàm lấy thông tin khóa học object để hiển thị vào card popular
    function displayCardPopular(paramCourseObj){
      var html = `<div class = "col-sm-3">
          <div class="card" style="width: 18rem;">
            <img class="card-img-top" src="${paramCourseObj.coverImage}" alt="Card image cap">
            <div class="card-body">
              <p class="card-text text-primary font-weight-bold">${paramCourseObj.courseName}</p>
              <p class=" text-muted m-1"><i class = "far fa-clock"></i> ${paramCourseObj.duration} ${paramCourseObj.level}</p>
              <p><span class="font-weight-bold m-1">${paramCourseObj.discountPrice}</span>
                <del class="text-muted m-1">${paramCourseObj.price}</del></p>
            </div>
            <div class="card-footer">
              <div>
                <img class="img-teacher" src="${paramCourseObj.teacherPhoto}" alt="Avatar" style="width:30px">
                <small class="text-muted m-1">${paramCourseObj.teacherName}</small><i class="fa fa-bookmark float-right text-muted m-1"></i>
              </div>
            </div>
          </div>
        </div>`;
      $("#most-popular").append(html);
    }
    //hàm lấy thông tin khóa học object để hiển thị vào card trending
    function displayCardTrending(paramCourseObj){
      var html = `<div class = "col-sm-3">
          <div class="card" style="width: 18rem;">
            <img class="card-img-top" src="${paramCourseObj.coverImage}" alt="Card image cap">
            <div class="card-body">
              <p class="card-text text-primary font-weight-bold">${paramCourseObj.courseName}</p>
              <p class=" text-muted m-1"><i class = "far fa-clock"></i> ${paramCourseObj.duration} ${paramCourseObj.level}</p>
              <p><span class="font-weight-bold m-1">${paramCourseObj.discountPrice}</span>
                <del class="text-muted m-1">${paramCourseObj.price}</del></p>
            </div>
            <div class="card-footer">
              <div>
                <img class="img-teacher" src="${paramCourseObj.teacherPhoto}" alt="Avatar" style="width:30px">
                <small class="text-muted m-1">${paramCourseObj.teacherName}</small><i class="fa fa-bookmark float-right text-muted m-1"></i>
              </div>
            </div>
          </div>
        </div>`;
      $("#most-trending").append(html);
    }
</script>
</html>